$!---------------make.com for xpm_examples----------------------------------
$! make xpm examples under VMS
$!
$! In case of problems with the build you might want to contact me at 
$! m.zinser@gsi.de (preferred) or eurmpz@eur.sas.com (Work)
$!
$ Make = ""
$ X11check = 0
$!
$! Check for MMK/MMS
$!
$ If F$Search ("Sys$System:MMS.EXE") .nes. "" Then Make = "MMS"
$ If F$Type (MMK) .eqs. "STRING" Then Make = "MMK"
$!
$! Check for advanced X11-logical
$!
$ if f$search("X11:xpm.h").eqs."" then x11check = 1
$ if f$search("X11:shape.h").eqs."" then x11check = 1 
$ if (x11check)
$ then
$  write sys$output "Your X11-logical does not point to the directories"
$  write sys$output "containing xpm.h and/or shape.h."
$  write sys$output "Please redefine X11 to include these."
$  write sys$output "An example how this might look like follows"
$  write sys$output "$!"
$  write sys$output "$! Get definitions for non-DECsupplied libs and missing routines/includes"
$  write sys$output "$! At the moment supported are: XMU, XAW, and XPM"
$  write sys$output "$!"
$  write sys$output "$!"
$  write sys$output "$ decwf = """""
$  write sys$output "$ if f$search(""sys$common:[000000]decw$include.dir"").nes. """" "
$  write sys$output "$  then"
$  write sys$output "$    decwf = f$trnlnm(""sys$common"")"
$  write sys$output "$    decwf = decwf -""]"" + ""decw$include.],"" "
$  write sys$output "$ endif"
$  write sys$output "$ define/nolog X11 'decwf'X11ADD,X11ADD:[XPM.LIB],DECW$INCLUDE"
$  exit
$ endif
$!
$! Produce linker-options file according to X-Release and compiler used
$!
$ open/write optf xpmex.opt
$ write optf "pubbin:libxpm.olb/lib"
$ write optf "sys$share:decw$xextlibshr.exe/share"
$ write optf "sys$share:decw$xlibshr.exe/share"
$ @sys$update:decw$get_image_version sys$share:decw$xlibshr.exe decw$version
$ if f$extract(4,3,decw$version).eqs."1.1"
$ then
$   write optf "sys$share:decw$xmlibshr.exe/share"
$   write optf "sys$share:decw$xtshr.exe/share"
$ endif
$ if f$extract(4,3,decw$version).eqs."1.2"
$ then
$   write optf "sys$share:decw$xmlibshr12.exe/share"
$   write optf "sys$share:decw$xtlibshrr5.exe/share"
$ endif
$ if f$getsyi("HW_MODEL").ge.1024
$ then
$  cc :== "cc/prefix=all"
$  if f$trnlnm("SYS").eqs."" then define sys sys$library:
$ else
$  if f$search("SYS$SYSTEM:DECC$COMPILER.EXE").eqs.""
$   then
$    cc :== "cc"
$    write optf "sys$share:vaxcrtl.exe/share"
$    if f$trnlnm("SYS").eqs."" then define sys sys$library:
$   else
$    cc :== "cc/prefix=all"
$    if f$trnlnm("SYS").eqs."" then define sys decc$library_include:
$  endif
$ endif
$ close optf
$!
$! Build the thing plain or with 'Make'
$!
$ write sys$output "Compiling XPM example sources ..."
$  if (Make .nes. "")
$   then
$    'Make'
$  else
$   CALL MAKE button.OBJ "CC  button" -
              button.c  
$   CALL MAKE button2.OBJ "CC  button2" -
              button2.c  
$   CALL MAKE button3.OBJ "CC  button3" -
              button3.c  
$   CALL MAKE button4.OBJ "CC  button4" -
              button4.c  
$   CALL MAKE button5.OBJ "CC  button5" -
              button5.c  
$   CALL MAKE button6.OBJ "CC  button6" -
              button6.c  
$   write sys$output "Linking XPM examples ..."
$   CALL MAKE button.EXE "LINK  button,xpmex.opt/OPT" button.OBJ
$   CALL MAKE button2.EXE "LINK  button2,xpmex.opt/OPT" button2.OBJ
$   CALL MAKE button3.EXE "LINK  button3,xpmex.opt/OPT" button3.OBJ
$   CALL MAKE button4.EXE "LINK  button4,xpmex.opt/OPT" button4.OBJ
$   CALL MAKE button5.EXE "LINK  button5,xpmex.opt/OPT" button5.OBJ
$   CALL MAKE button6.EXE "LINK  button6,xpmex.opt/OPT" button6.OBJ
$  endif
$ write sys$output "XPM Examples build completed"
$ exit
$!
$!
$MAKE: SUBROUTINE   !SUBROUTINE TO CHECK DEPENDENCIES
$ V = 'F$Verify(0)
$! P1 = What we are trying to make
$! P2 = Command to make it
$! P3 - P8  What it depends on
$
$ If F$Search(P1) .Eqs. "" Then Goto Makeit
$ Time = F$CvTime(F$File(P1,"RDT"))
$arg=3
$Loop:
$       Argument = P'arg
$       If Argument .Eqs. "" Then Goto Exit
$       El=0
$Loop2:
$       File = F$Element(El," ",Argument)
$       If File .Eqs. " " Then Goto Endl
$       AFile = ""
$Loop3:
$       OFile = AFile
$       AFile = F$Search(File)
$       If AFile .Eqs. "" .Or. AFile .Eqs. OFile Then Goto NextEl
$       If F$CvTime(F$File(AFile,"RDT")) .Ges. Time Then Goto Makeit
$       Goto Loop3
$NextEL:
$       El = El + 1
$       Goto Loop2
$EndL:
$ arg=arg+1
$ If arg .Le. 8 Then Goto Loop
$ Goto Exit
$
$Makeit:
$ VV=F$VERIFY(0)
$ write sys$output P2
$ 'P2
$ VV='F$Verify(VV)
$Exit:
$ If V Then Set Verify
$ENDSUBROUTINE

